unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  xsdins, StdCtrls, strs, xmls, Grids, DBGrids, ComCtrls, ToolWin, Db,
  FIBDatabase, pFIBDatabase, FIBDataSet, pFIBDataSet, xsdedit, ImgList;

type
  TForm1 = class(TForm)
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    XE: TXMLInspector;
    FDB: TpFIBDatabase;
    Cust: TpFIBDataSet;
    pFIBTransaction1: TpFIBTransaction;
    pFIBTransaction2: TpFIBTransaction;
    dsCust: TDataSource;
    ToolBar1: TToolBar;
    AddBtn: TToolButton;
    EditBtn: TToolButton;
    DBGrid1: TDBGrid;
    CustCUST_NO: TFIBIntegerField;
    CustCUSTOMER: TFIBStringField;
    CustCONTACT_FIRST: TFIBStringField;
    CustCONTACT_LAST: TFIBStringField;
    CustPHONE_NO: TFIBStringField;
    CustADDRESS_LINE1: TFIBStringField;
    CustADDRESS_LINE2: TFIBStringField;
    CustCITY: TFIBStringField;
    CustSTATE_PROVINCE: TFIBStringField;
    CustCOUNTRY: TFIBStringField;
    CustPOSTAL_CODE: TFIBStringField;
    CustON_HOLD: TFIBStringField;
    HotImages: TImageList;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure AddBtnClick(Sender: TObject);
  private
    function GenerateXSD(Dataset: TDataSet): string;
    { Private declarations }
  public
    Schema: TXMLNode;
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject);
begin

 //     
 Schema:=TXMLNode.CreateFromFile(ExtractFilePath(ParamStr(0))+'schema.xsd');
 XE.Schema:=Schema.NodebyAttr('name', 'LegalCustomer');
 try
  XE.CurNode:=TXMLNode.CreatefromFile(ExtractFilePath(ParamStr(0))+'account.xml')
 except
  XE.CurNode:=CreateXMLTemplate(XE.Schema, True);
 end;
 // FDB.DBName:=ExtractFilePath(ParamStr(0))+'fibex.gdb';
 // kfjhkjhsd
 
 FDB.Connected:=True;
 Cust.Open;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
 StrtoFile(XE.CurNode.FormattedCode(' '), ExtractFilePath(ParamStr(0))+'account.xml');
end;

function TForm1.GenerateXSD(Dataset: TDataSet): string;
var i: Integer; SN, SQN, XN: TXMLNode; F: TField;
begin
 SN:=TXMLNode.Create('<xsd:element name="A"></xsd:element>');
 try
  for i:=0 to Dataset.FieldCount-1 do begin
   F:=Dataset.Fields[i];
   if not F.ReadOnly then begin
    XN:=SN.Nodes.AddNode('xsd:attribute');
    XN.Attr['name']:='_'+AnsiLowerCase(F.FieldName);
    XN.Node['xsd:annotation/xsd:documentation']:=F.DisplayName;
    if F.DataType=ftInteger then XN.Attr['type']:='xsd:integer' else XN.Attr['type']:='xsd:string';
    if F.Required then XN.Attr['use']:='required';
   end;
  end;
  Result:='<xsd:schema>'+SN.Code+'</xsd:schema>';
 finally SN.Free end;
end;

procedure TForm1.AddBtnClick(Sender: TObject);
var XE: TXSDEditor; SN: TXMLNode;
begin
 SN:=nil;
 XE:=TXSDEditor.Create(Self);
 try
  SN:=TXMLNode.Create(GenerateXSD(Cust));
  if Sender=AddBtn then begin
   Cust.Append;
   XE.Caption:='New Customer';
  end else begin
   Cust.Edit;
   XE.Caption:='Edit Customer';
  end;
  try
   XE.Run(SN[0], CreateXMLTemplate(SN[0], True), Cust);
   if XE.ModalResult=mrOk then Cust.Post else Cust.Cancel;
  except Cust.Cancel; raise end;
 finally XE.Free; SN.Free end;
end;

end.
